//3/3/03 - 20/8/03 version 6
//A window with controls for tantech
//3/5/03 Auto alpha sort, team option removed
//20/08/03 Removed sort button
//         Added arena list
//         Changed input from TextField to TextArea

//import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class window extends java.applet.Applet
                    implements ActionListener, TextListener {
  static final int version = 6;

  private Frame f;
  private Panel p;
  private TextArea  out;
  private List      userList;
  private List      arenaList;
  private TextArea  in;

  String data;
  boolean bNewData = false;
  boolean bQuitEvt = false;

//
// Events
//

  public void textValueChanged(TextEvent e) {
    //Don't send "new lines"
    if (in.getText().equals("\n")) {
        in.setText("");
        return;
    }

    if (in.getText().endsWith("\n") || in.getText().endsWith("\r")) {
        data = in.getText();
        //Don't send the "\n"
        data = data.substring(0, data.length() - 1);
        in.setText("");
        bNewData = true;
    }
  }

  public void actionPerformed(ActionEvent evt) {
    String arg = evt.getActionCommand();

    if (!in.getText().equals("")) {
        data = in.getText();
        in.setText("");
        bNewData = true;
    }
  }

  public boolean winCloseEvent() {
    return bQuitEvt;
  }

//
// I/O
//

  public void println(String str) {
    //System.out.println("ECHO " + str);
    //out.append(str + "\n");
    out.append("\n" + str);
  }

  //// Players ////

  public void addUser(String str) {
    userList.add(str);
    //There must always be something selected
    if (userList.getItemCount() == 1) userList.select(0);
    sortListAlpha();
  }

  public void removeUser(String str) {
    userList.remove(str);
  }

  public String getUser() {
    return userList.getSelectedItem();
  }

  //// Arenas ////

  public void addArena(String str) {
    arenaList.add(str);
    //There must always be something selected
    if (arenaList.getItemCount() == 1) arenaList.select(0);
  }

  public void removeArena(String str) {
    arenaList.remove(str);
  }

  public void clearArena() {
    arenaList.removeAll();
  }

  public String getArena() {
    return arenaList.getSelectedItem();
  }

  public String readLine() {
    bNewData = false;
    return data;
  }

  public boolean ready() {
    return bNewData;
  }

//
// Player
//

  public void sortListAlpha() {
    //Store selected name
    String selected = userList.getSelectedItem();

    //Keep this users name for later
    String yours = userList.getItem(0);
    //userList.remove(yours);

    //2 or less names, don't bother
    if (userList.getItemCount() < 3) return;
    else userList.remove(yours);

    //Store all names
    String[] names = userList.getItems();
    userList.removeAll();

    //Sort names
    int i=names.length, j=0; String str;
    while(i-- > 0) {
      str = names[i]; //Get current name

      //Cycle names[] for something > to current name
      j=names.length; while(j-- > 0) {
        if (names[j].compareTo(str) > 0) {
          //Swap
          str = names[i];
          names[i] = names[j];
          names[j] = str;
        }
      }
    }

    //Restore names
    userList.add(yours);
    i=names.length; while(i-- > 0) userList.add(names[i]);

    //Restore selected name
    i=userList.getItemCount(); while(i-- > 0) {
      userList.select(i);
      if (userList.getSelectedItem().equals(selected))
        break;
    }
  }

//
// Core
//

  public window() {
    Color uiColor = new Color(123, 140, 90);
    Font  uiFont  = new Font("Monospaced", Font.PLAIN, 12);
    setLayout(new BorderLayout());
    p = new Panel(new BorderLayout(2,2));
    add("Center", p);

    //Message output area
    out = new TextArea("  Type ?quit to exit", 19, 68,
            TextArea.SCROLLBARS_VERTICAL_ONLY); //rows, cols
    out.setEditable(false);
    //"Monospaced" or "Courier"
    out.setFont(uiFont);
    out.setBackground(uiColor);
    p.add("Center", out);

    //Names area
    Panel n = new Panel(new BorderLayout(2,2));
    p.add("East", n);
    //Player name list
    userList = new List();
    userList.setBackground(uiColor);
    userList.setFont(uiFont);
    n.add("Center", userList);
    //Arena list area
    arenaList = new List(); //30 wide
    arenaList.setBackground(uiColor);
    arenaList.setFont(uiFont);
    n.add("South", arenaList);

    //--Bottom panel
    Panel bottom = new Panel(new BorderLayout(2,2));
    p.add("South", bottom);
    //Input field
    in = new TextArea("", 1, 55,
           TextArea.SCROLLBARS_VERTICAL_ONLY); //rows, cols
    in.setFont(uiFont);
    in.setBackground(uiColor);
    in.addTextListener(this); //TextArea only
//    in.addActionListener(this); //TextField only
    bottom.add("Center", in);
  }

//
// Init
//

  public void init() {
  }

  //This is a bit vague as to how it works, but never mind!
  public void initRemote() {
    System.out.println("-- window v" + version + " --");
    /*Frame*/ f = new Frame("tantech");
    //Grr, I can't get a gap between the edge of the window and everything else
    //f.setLayout(new GridLayout(1,1, 4,4));

    window winMain = new window();
    winMain.init();
    winMain.start();

    WindowListener l = new WindowAdapter() {
        public void windowClosing(WindowEvent e) {
          bQuitEvt = true;
        }
      };
    f.addWindowListener(l);

    f.add("Center", this);
    f.setSize(630, 357);
    f.setBackground(new Color(123, 140, 90)); //7b8c5a
    f.pack(); //Supposed to align recently added controls
    f.show();
  }

  public void stopRemote() {
    this.stop();
    f.hide();
  }

}

/* [optional]
new List([rows]);
List.add("Text Here" [, indexvalhere]);
List.delItem(indexvalhere);
List.getSelectedIndex();
List.getSelectedItem();
List.isSelected(indexvalhere);
List.remove("Text Here");
List.select(indexvalhere);
*/
